# -*- coding: utf-8 -*-
# Konvertiert einen Outlook-Kontakte-Telefonbuch-Export
# in ein SNOM-Import-fähiges CSV

import csv

# Man definiere hier die Spalten, deren Nummern im Ziel-CSV
# Für jeden Kontakt enthalten sein sollen:

columnsToExport = [
	"Telefon geschäftlich",
	"Telefon Firma",
	"Telefon privat",
	"Telefon privat 2",
	"Mobiltelefon",
	"Haupttelefon",
	"Mobiltelefon 2",
	"Büro"
]

columnsToExportLabels  = []
columnsToExportIndices = []

# Spaltenüberschriften für Vor- und Nachname
surnameHeader   = "Nachname"
surnameIndex    = 0
givenNameHeader = "Vorname"
givenNameIndex  = 0

# Hier wird die Landesvorwahl eingestellt.
# Diese wird aus der Telefonnummer entfernt,
# oder, falls eine andere +??? Nummer gefunden
# wird, wird diese mit 00 ersetzt.
CountryCode = "+49"

# Präfix: Soll eine bestimmte Ziffer vorgewählt
# werden?
Prefix = "0"

inFile  = csv.reader(open('in.csv'), delimiter=',', quotechar='"')
outFile = csv.writer(open('out.csv', 'w'), delimiter=',', quotechar='"', quoting=csv.QUOTE_ALL, lineterminator="\n")
i = -1
idsOfContactsUsed = []

for row in inFile:
	i = i+1
	for j in range(len(row)):
		row[j] = row[j].strip().decode("iso-8859-1").encode("utf-8")
	
	if i==0:
		# Ok, erste Zeile mit Überschriften:
		for j in range(len(row)):
			if row[j]== surnameHeader:
				surnameIndex = j
				print surnameHeader + " in Spalte " +str(j) +" gefunden."
			if row[j]== givenNameHeader:
				givenNameIndex = j
				print givenNameHeader + " in Spalte " +str(j) +" gefunden."
			for k in range(len(columnsToExport)):
				if columnsToExport[k] == row[j]:
					columnsToExportLabels.append(row[j])
					columnsToExportIndices.append(j);
					break;
				
		if givenNameIndex== 0 or surnameIndex == 0:
			print "FEHLER: Vornamens- oder Nachnamensspalte nicht gefunden."
			break

		print columnsToExportIndices
		continue

	if row[surnameIndex].strip() == "" or row[givenNameIndex].strip() == "":
		print row[surnameIndex] +", "+ row[givenNameIndex] +":"
		print "FEHLER: Vor- oder Nachname leer, übersprungen."
		print " "
		continue
		
	print row[surnameIndex] +", "+ row[givenNameIndex] +":"
	numbersForContact = 0
	idOfContact = ""
	for j in range(len(columnsToExportLabels)):
		nummer = row[columnsToExportIndices[j]].strip().replace(" ", "").replace("-", "").replace(")", "").replace("(", "").replace("/", "").replace("\\", "").replace(".", "").replace("_", "")
		nummer = nummer.replace(CountryCode, "0")
		nummer = nummer.replace("+", "00")
		if nummer == "":
			continue
		numbersForContact = numbersForContact + 1
		nummer = Prefix + nummer

		# Erste Nummer als Contact-ID benutzen
		if idOfContact == "":
			nrToAppend = 0
			idOfContact = nummer
			while 1:
				if idOfContact in idsOfContactsUsed:
					nrToAppend = nrToAppend + 1
					idOfContact = idOfContact + str(nrToAppend)
					continue
				break
			idsOfContactsUsed.append(idOfContact)
			
		print "  "+ columnsToExportLabels[j] +": " + nummer
		# Client-Record zusammenbauen
		# Home,"008986488829","","line1","Member_Alias","008986488829","","","","","1.1.1982","","false","","","home"
		clientRecord = [
			columnsToExportLabels[j],
			nummer,
			"",
			"active",
			"Member_Alias",
			idOfContact,
			"",
			"",
			"",
			"",
			"",
			"",
			"false",
			"",
			"",
			"home"
		]
		
		# ... und schreiben
		outFile.writerow(clientRecord)

	if numbersForContact == 0:
		print "FEHLER: Keine Telefonnummern vorhanden, übersprungen."
		print " "
		continue
	
	# Master-Record zusammenbauen
	# Ferdinand Timmermann,"008986488829","MASTER","","Ferdinand","Timmermann","","Air Berlin","tim@gmx.net","keine Notiz","1.1.1982","friend","false","","",""
	clientRecord = [
		"",
		idOfContact,
		"MASTER",
		"",
		row[givenNameIndex],
		row[surnameIndex],
		"",
		"",
		"",
		"",
		"",
		"friend",
		"false",
		"",
		"",
		""
	]
	outFile.writerow(clientRecord)
	print " "

#Mobilfunk,"001729620845","","line1","Member_Alias","008986488829","","","","","1.1.1982","","false","","","home"


	